' Modulsammlung fr Grafik-Import und Export von QuickBASIC-
' GET/PUT-Grafikfeldern ins Windows Bitmap (*.BMP)-Format und
' umgekehrt sowie Laden der Farbpalette

' (c) 1999 by Andreas Meile, CH-8242 Hofen SH

DECLARE SUB HoleBildInfo (dn$, xb&, yb&, bpp%, gr%)
' Ermittelt Bildattribute:
' xb&, yb&  : Grsse
' bpp%      : Farbtiefe
' gr%       : Grsse des Bildes

DECLARE SUB LadeBild (dn$, f%(), ind%)
' Ldt Bild dn$ ins Feld f%() ab Startindex ind%
' ind% ist fr Animationen vorgesehen, um mehrere Bilder
' ins gleiche Feld laden knnen

DECLARE SUB LadePalette (dn$, p&(), ind%, mo%)
' Ldt Farbpalette Bild dn$ ins Feld f%() ab Startindex ind%
' ind% ist fr mehrere Paletten pro Feld vorgesehen
' mo% = Farbpalettenmodus

DECLARE SUB SpeichereBild (dn$, f%(), indf%, p&(), indp%, bpp%, mo%)
' Ausschnitt als Datei speichern. Bedeutung:
' dn$   = Dateiname ohne Endung ".BMP"
' f%()  = mit GET() ausgeschnittene Grafik, indf% = Startindex
' p&()  = fr PALETTE USING bestimmte Farbpalette, indp% = Startindex
' bpp%  = Bildtiefe in Bits pro Pixel
' mo%   = Farbpalettenmodus

' Werte fr Farbpalettenmodus mo%
CONST PalCGA% = 0   ' fr SCREEN 1/2/7/8
CONST PalEGA% = 1   ' fr SCREEN 0/9
CONST PalVGA% = 2   ' fr SCREEN 11/12/13
CONST PalVlf% = 3   ' verlustfreier Spezialmodus

FILES "*.bmp"
INPUT "Dateiname (ohne .BMP!)"; d$
HoleBildInfo d$, b&, h&, t%, g%
PRINT "Dieses Bild ist"; b&; "x"; h&; "Pixel gross und"; t%; "Bit(s) tief."
PRINT "Grsse des GET/PUT-Feldes"; g%; "Elemente"
PRINT "Weiter mit Taste"; INPUT$(1)
DIM h%(g% - 1), pa&(255)
pf% = 0
pp% = 0
LadeBild d$, h%(), pf%

SELECT CASE t%
CASE 1
  IF h& <= 200& THEN
    SCREEN 2
    LadePalette d$, pa&(), pp%, PalCGA%
  ELSEIF b& <= 640& AND h& <= 480& THEN
    SCREEN 11
    LadePalette d$, pa&(), pp%, PalVGA%
  ELSE
    PRINT "Bild zu gross!"
    END
  END IF
CASE 4
  IF h& <= 200& THEN
    IF w& <= 320& THEN
      SCREEN 7
    ELSE
      SCREEN 8
    END IF
    LadePalette d$, pa&(), pp%, PalCGA%
  ELSEIF h& <= 350& THEN
    SCREEN 9
    LadePalette d$, pa&(), pp%, PalEGA%
  ELSEIF b& <= 640& AND h& <= 480& THEN
    SCREEN 12
    LadePalette d$, pa&(), pp%, PalVGA%
  ELSE
    PRINT "Bild zu gross!"
    END
  END IF
CASE 8
  IF b& <= 320& AND h& <= 200& THEN
    SCREEN 13
    LadePalette d$, pa&(), pp%, PalVGA%
  ELSE
    PRINT "Bild zu gross!"
    END
  END IF
CASE 24
  PRINT "Echtfarb (TrueColor) nicht untersttzt!"
  END
CASE ELSE
  PRINT "Nicht untersttzte Tiefe:"; t%
  END
END SELECT

' Grsse messen
bx% = 0
WHILE POINT(bx%, 0) <> -1
  bx% = bx% + 1
WEND
by% = 0
WHILE POINT(0, by%) <> -1
  by% = by% + 1
WEND
brx% = bx% \ 52
bry% = by% \ 39
anzx% = (bx% - 1) \ brx%
anzy% = (by% - 1) \ bry%
' Vieregglimuster erzeugen
FOR y% = 0 TO anzy%
  FOR x% = 0 TO anzx%
    SELECT CASE t%
    CASE 1
      f% = (x% XOR y%) AND 1
    CASE 4
      f% = (x% AND 3) + 4 * (y% AND 3)
    CASE 8
      f% = (x% AND 15) + 16 * (y% AND 15)
    END SELECT
    LINE (brx% * x%, bry% * y%)-STEP(brx% - 1, bry% - 1), f%, BF
  NEXT x%
NEXT y%

PUT ((bx% - CINT(b&)) \ 2, (by% - CINT(h&)) \ 2), h%, PSET
PALETTE USING pa&

d$ = INPUT$(1)
' Pltteln

hx% = CINT(b&) + 4
hy% = CINT(h&) + 4
anzx% = (bx% + 2) \ hx%
anzy% = (by% + 2) \ hy%
FOR y% = 0 TO anzy% - 1
  FOR x% = 0 TO anzx% - 1
    PUT (2 + x% * hx%, 2 + y% * hy%), h%, PSET
  NEXT x%
NEXT y%

LOCATE 20, 1
PRINT "Index Bild:"; pf%; "(Soll:"; g%; ") Pal.:"; pp%; "(t="; t%; ")"

' Test mit Speichern
DIM hf%(5), hf2%, h2%(7000)
ind% = LBOUND(h2%)
hf%(0) = ind%
FOR i% = 1 TO 5
  GET (50 * i%, 20)-STEP(20 + 5 * i%, 21 - 3 * i%), h2%(ind%)
  i2% = LBOUND(pa&)
  SpeichereBild "Test" + CHR$(48 + i%), h2%(), ind%, pa&(), i2%, t%, t% \ 4
  hf%(i%) = ind%
NEXT i%
' Zeichnen
FOR i% = 0 TO 4
  PUT (20 + 52 * i%, 40), h2%(hf%(i%)), PSET
NEXT i%
' Lschen
FOR i% = LBOUND(h2%) TO UBOUND(h2%)
  h2%(i%) = 0
NEXT i%
' Sequenz laden
ind% = LBOUND(h2%)
LOCATE 14, 1
FOR i% = 0 TO 4
  HoleBildInfo "Test" + CHR$(49 + i%), x&, y&, t%, s%
  LadeBild "Test" + CHR$(49 + i%), h2%(), ind%
  PRINT x&; y&; t%; s%; hf%(i% + 1) - hf%(i%); ind%; hf%(i% + 1)
NEXT i%
PRINT i2%
d$ = INPUT$(1)
' Zeichnen
FOR i% = 0 TO 4
  PUT (20 + 52 * i%, 90), h2%(hf%(i%)), PSET
NEXT i%
d$ = INPUT$(1)
SCREEN 0
WIDTH 80, 25

SUB HoleBildInfo (dn$, xb&, yb&, bpp%, gr%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 19&
  xb& = CVL(INPUT$(4, 1))  ' Bildgrsse
  yb& = CVL(INPUT$(4, 1))
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  CLOSE 1
  IF bpp% = 4 THEN
    ze& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
  ELSE
    ze& = (xb& * CLNG(bpp%) + 7&) \ 8&
  END IF
  gr% = 2 + CINT((ze& * yb& + 1&) \ 2&)
END SUB

SUB LadeBild (dn$, f%(), ind%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 11&
  basOf& = CVL(INPUT$(4, 1)) + 1&  ' ab hier beginnen die Nutzdaten
  SEEK 1, 19&
  xb& = CVL(INPUT$(4, 1))  ' Bildgrsse
  yb& = CVL(INPUT$(4, 1))
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  komp& = CVL(INPUT$(4, 1))
  IF komp& <> 0& THEN
    PRINT "Komprimierung nicht untersttzt"
    ERROR 5
  END IF
  ' Start der Verarbeitung
  br& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
  IF bpp% = 8 THEN
    f%(ind%) = 8 * CINT(xb&)
  ELSE
    f%(ind%) = CINT(xb&)
  END IF
  f%(ind% + 1) = CINT(yb&)
  ind% = ind% + 2
  SELECT CASE bpp%
  CASE 1, 8
    IF bpp% = 1 THEN
      b% = CINT((xb& + 7&) \ 8&)
    ELSE
      b% = CINT(xb&)
    END IF
    Pu$ = ""
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x% = 1 TO b%
        Pu$ = Pu$ + INPUT$(1, 1)
        IF LEN(Pu$) = 2 THEN
          f%(ind%) = CVI(Pu$)
          ind% = ind% + 1
          Pu$ = ""
        END IF
      NEXT x%
    NEXT y&
    IF Pu$ <> "" THEN
      f%(ind%) = CVI(Pu$ + " ")
      ind% = ind% + 1
    END IF
  CASE 4
    DIM h%(3)
    FOR i% = 0 TO 3
      h%(i%) = 0
    NEXT i%
    b% = CINT(br&) \ 4
    pu1$ = SPACE$(4 * b%)
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x1% = 1 TO b%
        FOR x2% = 1 TO 4
          z% = ASC(INPUT$(1, 1))
          FOR x3% = 0 TO 3
            h%(x3%) = 4 * h%(x3%) + (z% AND 1) + (z% AND 16) \ 8
            z% = z% \ 2
          NEXT x3%
        NEXT x2%
        FOR i% = 0 TO 3
          MID$(pu1$, x1% + b% * i%) = CHR$(h%(i%))
          h%(i%) = 0
        NEXT i%
      NEXT x1%
      FOR i% = 1 TO LEN(pu1$) STEP 2
        f%(ind%) = CVI(MID$(pu1$, i%, 2))
        ind% = ind% + 1
      NEXT i%
    NEXT y&
  CASE 24
    PRINT "Echtfarb (True Color) nicht mglich"
    ERROR 5
  CASE ELSE
    PRINT "Unbekannte Bildtiefe"
    ERROR 5
  END SELECT
  CLOSE 1
END SUB

SUB LadePalette (dn$, p&(), ind%, mo%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 15&
  palOf& = CVL(INPUT$(4, 1)) + 15&   ' ab hier beginnen die Farbeintrge
  SEEK 1, 27&
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  IF bpp% > 12 THEN
    PRINT "Echtfarb verwendet keine Farbpalette"
    ERROR 5
  END IF
  ' Start der Verarbeitung
  aF% = 1
  FOR i% = 1 TO bpp%
    aF% = aF% * 2
  NEXT i%
  IF mo% = PalVlf% THEN
    ' verlustfreier Spezialmodus, der keinem SCREEN gehrt
    ' liest gesamter RGBQUAD ein
    SEEK 1, palOf&
    FOR i% = 1 TO aF&
      p&(ind%) = CVL(INPUT$(4, 1))
      ind% = ind% + 1
    NEXT i%
  ELSE
    FOR i% = 1 TO aF%
      SEEK 1, palOf&
      b% = ASC(INPUT$(1, 1))
      g% = ASC(INPUT$(1, 1))
      r% = ASC(INPUT$(1, 1))
      SELECT CASE mo%
      CASE PalCGA%  ' CGA-Palette von SCREEN 1/2/7/8
        Cga% = (r% AND 128) \ 32 + (g% AND 128) \ 64 + (b% AND 128) \ 128
        ' Selektion, ob hellerer oder dnklerer Farbton darstellen
        h% = (r% AND 127) + (g% AND 127) + (b% AND 127) - 192
        p&(ind%) = CLNG(Cga% - 8 * (h% > 0))
        IF p&(ind%) = 4 AND g% > 80 THEN
          p&(ind%) = 6   ' Spezialfall Orange
        END IF
      CASE PalEGA%  ' EGA-Palette von SCREEN 0/9
        p&(ind%) = CLNG((r% AND 64) \ 2 + (r% AND 128) \ 32 + (g% AND 64) \ 4 + (g% AND 128) \ 64 + (b% AND 64) \ 8 + (b% AND 128) \ 128)
      CASE PalVGA%  ' VGA-Palette von SCREEN 11/12/13
        p&(ind%) = CLNG(r% AND 252) \ 4& + CLNG(g% AND 252) * 64& + CLNG(b% AND 252) * 16384&
      CASE ELSE
        ERROR 5
      END SELECT
      palOf& = palOf& + 4&
      ind% = ind% + 1
    NEXT i%
  END IF
  CLOSE 1
END SUB

SUB SpeichereBild (dn$, f%(), indf%, p&(), indp%, bpp%, mo%)
  CONST dpm& = 60& * 5000& \ 127&  ' Dichte: 60 dpi = 2362 Pixel/Meter
  aFa% = 1
  FOR i% = 1 TO bpp%
    aFa% = aFa% * 2
  NEXT i%
  BitmAbst& = CLNG(14 + 40 + 4 * aFa%)
  IF bpp% = 8 THEN
    xb& = CLNG(f%(indf%) \ 8)
  ELSE
    xb& = CLNG(f%(indf%))
  END IF
  yb& = CLNG(f%(indf% + 1))
  ' Zeilenlnge in der Datei
  ZeiLaenge& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
  BildGroe& = yb& * ZeiLaenge&
  GesGroe& = BildGroe& + BitmAbst&

  OPEN dn$ + ".BMP" FOR OUTPUT AS 1
  ' BITMAPFILEHEADER schreiben
  PRINT #1, "BM"; MKL$(GesGroe&); MKI$(0); MKI$(0); MKL$(BitmAbst&);
  ' BITMAPINFOHEADER schreiben
  PRINT #1, MKL$(40&); MKL$(xb&); MKL$(yb&); MKI$(1); MKI$(bpp%); MKL$(0&);
  PRINT #1, MKL$(BildGroe&); MKL$(dpm&); MKL$(dpm&); MKL$(0&); MKL$(0&);

  ' Farbpalette schreiben: Dabei werden die hintersten Bits entsprechend
  ' gefllt, also z.B. bei EGA aus 10 => 10101010 => damit bleibt Weiss
  ' auch wirklich weiss, und wird nicht wie bei alten DeluxePaint-Versionen
  ' zu 240er- bzw. 192er-Grau umgewandelt

  FOR i% = 1 TO aFa%
    IF mo% = PalVlf% THEN
      PRINT #1, MKL$(p&(indp%));
    ELSE
      ' BASIC-Palettenfarben der PALETTE-Anweisung in RGB-Werte umwandeln
      SELECT CASE mo%
      CASE PalCGA%  ' CGA-Palette von SCREEN 1/2/7/8
        r% = 85 * (CINT(p&(indp%) AND 4&) \ 2 + CINT(p&(indp%) AND 8&) \ 8)
        g% = 85 * (CINT(p&(indp%) AND 2&) + CINT(p&(indp%) AND 8&) \ 8)
        b% = 85 * (CINT(p&(indp%) AND 1&) * 2 + CINT(p&(indp%) AND 8&) \ 8)
        IF p&(indp%) = 6& THEN   ' Spezialfall Orange
          g% = 85
        END IF
      CASE PalEGA%  ' EGA-Palette von SCREEN 0/9
        r% = 85 * (CINT(p&(indp%) AND 32&) \ 32 + CINT(p&(indp%) AND 4&) \ 2)
        g% = 85 * (CINT(p&(indp%) AND 16&) \ 16 + CINT(p&(indp%) AND 2&))
        b% = 85 * (CINT(p&(indp%) AND 8&) \ 8 + CINT(p&(indp%) AND 1&) * 2)
      CASE PalVGA%  ' VGA-Palette von SCREEN 11/12/13
        r% = CINT(p&(indp%) * 4& AND 252&) + CINT(p&(indp%) \ 16& AND 3&)
        g% = CINT(p&(indp%) \ 64& AND 252&) + CINT(p&(indp%) \ 4096& AND 3&)
        b% = CINT(p&(indp%) \ 16384& AND 252&) + CINT(p&(indp%) \ 1048576 AND 3&)
      CASE ELSE
        PRINT "Ungltiger Palettenmodus"
        ERROR 5
      END SELECT
      PRINT #1, CHR$(b%); CHR$(g%); CHR$(r%); CHR$(0);
    END IF
    indp% = indp% + 1
  NEXT i%
  indf% = indf% + 2

  ' Bitmapdaten selber speichern
  SELECT CASE bpp%
  CASE 4
    ' 4bpp-Modus
    DIM h%(3)
    zl2% = CINT(ZeiLaenge& \ 4&)
    pu1$ = SPACE$(4 * zl2%)
    pu2$ = SPACE$(4)
    FOR y% = indf% + CINT(yb& - 1&) * 2 * zl2% TO indf% STEP -2 * zl2%
      FOR x% = 0 TO 2 * zl2% - 1
        MID$(pu1$, 2 * x% + 1) = MKI$(f%(y% + x%))
      NEXT x%
      FOR i% = 1 TO zl2%
        FOR j% = 0 TO 3
          h%(j%) = ASC(MID$(pu1$, i% + zl2% * j%))
        NEXT j%
        FOR j% = 4 TO 1 STEP -1
          w% = 0
          FOR k% = 3 TO 0 STEP -1
            w% = 2 * w% + (h%(k%) AND 1) + (h%(k%) AND 2) * 8
            h%(k%) = h%(k%) \ 4
          NEXT k%
          MID$(pu2$, j%) = CHR$(w%)
        NEXT j%
        PRINT #1, pu2$;
      NEXT i%
    NEXT y%
    indf% = indf% + CINT(yb&) * 2 * zl2%
  CASE 1, 8
    ' Zeilenlnge in Bytes im GET/PUT-Feld
    zl2& = (xb& * CLNG(bpp%) + 7&) \ 8&
    rest% = CINT(ZeiLaenge& - zl2&)
    FOR y& = 2& * CLNG(indf%) + (yb& - 1&) * zl2& TO 2& * CLNG(indf%) STEP -zl2&
      FOR x& = y& TO y& + zl2& - 1&
        z$ = MID$(MKI$(f%(CINT(x& \ 2&))), 1 + CINT(x& AND 1&), 1)
        PRINT #1, z$;
      NEXT x&
      ' Lcke fllen, damit 32-bit-aligned
      PRINT #1, STRING$(rest%, z$);
    NEXT y&
    indf% = indf% + CINT((yb& * zl2& + 1&) \ 2&)
  CASE ELSE
    PRINT "Ungltige Farbtiefe"
    ERROR 5
  END SELECT
  ' Kontrolle
  IF LOF(1) <> GesGroe& THEN
    PRINT "Fehler beim Speichern"
    ERROR 57
  END IF
  CLOSE 1
END SUB

